/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.pepo.providers;

import java.util.Iterator;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.ejb.LocalBean;
import javax.ejb.Schedule;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.transaction.HeuristicMixedException;
import javax.transaction.HeuristicRollbackException;
import javax.transaction.NotSupportedException;
import javax.transaction.RollbackException;
import javax.transaction.SystemException;
import javax.transaction.UserTransaction;
import org.pepo.controllers.Controller;
import org.pepo.entities.psql.Requests;

/**
 *
 * @author pepo
 */
@TransactionManagement(TransactionManagementType.BEAN)
@Stateless
@LocalBean
public class Provider {

    @PersistenceContext(unitName = "Psql-ejbPU")
    private EntityManager em;
    @Resource
    private UserTransaction ut;
    @EJB
    private Controller controller;

    @Schedule(minute = "*/1", hour = "*")
    public void Reader() {
        System.out.println("Each minute...");
        List<Requests> rList = controller.getRequests();
        if (rList != null && rList.size() > 0) {
            Iterator<Requests> vItrReq = rList.iterator();
            while (vItrReq.hasNext()) {
                try {
                    ut.begin();
                    Requests vReq = vItrReq.next();
                    System.out.println("Requerimiento: " + vReq.toString());

                    controller.setAction(vReq);

                    ut.commit();
                } catch (RollbackException ex) {
                    Logger.getLogger(Provider.class.getName()).log(Level.SEVERE, null, ex);
                } catch (HeuristicMixedException ex) {
                    Logger.getLogger(Provider.class.getName()).log(Level.SEVERE, null, ex);
                } catch (HeuristicRollbackException ex) {
                    Logger.getLogger(Provider.class.getName()).log(Level.SEVERE, null, ex);
                } catch (SecurityException ex) {
                    Logger.getLogger(Provider.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IllegalStateException ex) {
                    Logger.getLogger(Provider.class.getName()).log(Level.SEVERE, null, ex);
                } catch (NotSupportedException ex) {
                    Logger.getLogger(Provider.class.getName()).log(Level.SEVERE, null, ex);
                } catch (SystemException ex) {
                    Logger.getLogger(Provider.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }
}
